package com.greatchn.collection.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import java.io.Serializable;
import java.time.LocalDateTime;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;
import lombok.experimental.Accessors;

/**
 * <p>
 * 文件类型目录表（一个档案库仅执行一套文件类型标准）
 * </p>
 *
 * @author mybatis-plus-generator
 * @since 2022-08-02
 */
@Getter
@Setter
@Accessors(chain = true)
@TableName("erms_file_type")
public class ErmsFileTypePO extends Model<ErmsFileTypePO> {

    private static final long serialVersionUID = 1L;

    @TableId(value = "file_type_id", type = IdType.AUTO)
    private Integer fileTypeId;

    @TableField("file_type_name")
    private String fileTypeName;

    @TableField("qy_id")
    private Integer qyId;

    @TableField("file_type_role")
    private String fileTypeRole;

    @TableField("file_type_par")
    private Integer fileTypePar;

    @TableField("file_type_oder")
    private Integer fileTypeOder;

    /**
     * 档案类型键值(相同父级下键值不允许重复)
     */
    @TableField("file_type_key")
    private String fileTypeKey;

    /**
     * 插入时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @TableField("insert_date")
    private LocalDateTime insertDate;

    /**
     * 有效标志
     */
    @TableField("state")
    private String state;


    public static final String FILE_TYPE_ID = "file_type_id";

    public static final String FILE_TYPE_NAME = "file_type_name";

    public static final String FILE_TYPE_ROLE = "file_type_role";

    public static final String FILE_TYPE_PAR = "file_type_par";

    public static final String FILE_TYPE_ODER = "file_type_oder";

    public static final String FILE_TYPE_KEY = "file_type_key";

    public static final String INSERT_DATE = "insert_date";

    public static final String STATE = "state";

    @Override
    public Serializable pkVal() {
        return this.fileTypeId;
    }

}
