package com.greatchn.collection.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;

import java.io.Serializable;
import java.time.LocalDateTime;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;
import lombok.experimental.Accessors;

/**
 * <p>
 * 全宗信息（存档机构信息）-字段未完全补充，预留关联关系
 * </p>
 *
 * @author mybatis-plus-generator
 * @since 2022-08-11
 */
@Getter
@Setter
@Accessors(chain = true)
@TableName("erms_organization")
public class ErmsOrganizationPO extends Model<ErmsOrganizationPO> {

    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    @TableField("organization_no")
    private String organizationNo;

    @TableField("organization_name")
    private String organizationName;

    /**
     * 会计主管
     */
    @TableField("user_id")
    private String userId;

    /**
     * 插入时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @TableField(value = "insert_date", fill = FieldFill.INSERT)
    private LocalDateTime insertDate;

    /**
     * 更新时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @TableField(value = "update_date", fill = FieldFill.UPDATE)
    private LocalDateTime updateDate;

    /**
     * 插入人
     */
    @TableField(value = "insert_user", fill = FieldFill.INSERT)
    private Integer insertUser;

    /**
     * 更新人
     */
    @TableField(value = "update_user", fill = FieldFill.UPDATE)
    private Integer updateUser;

    /**
     * 备注
     */
    @TableField("remark")
    private String remark;

    /**
     * 有效标志
     */
    @TableField("state")
    private String state;

    public static final String ID = "id";

    public static final String ORGANIZATION_NO = "organization_no";

    public static final String ORGANIZATION_NAME = "organization_name";

    public static final String USER_ID = "user_id";

    public static final String INSERT_USER = "insert_user";

    public static final String UPDATE_USER = "update_user";

    public static final String INSERT_DATE = "insert_date";

    public static final String UPDATE_DATE = "update_date";

    public static final String REMARK = "remark";

    public static final String STATE = "state";

    @Override
    public Serializable pkVal() {
        return this.id;
    }

}
