package com.greatchn.collection.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 企业管理表，关联全宗号
 * </p>
 *
 * @author mybatis-plus-generator
 * @since 2022-11-25
 */
@Getter
@Setter
@Accessors(chain = true)
@TableName("erms_qiye")
public class ErmsQiyePO extends Model<ErmsQiyePO> {

    private static final long serialVersionUID = 1L;

    /**
     * 主键id，企业id
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 企业名称
     */
    @TableField("qy_name")
    private String qyName;

    /**
     * +全宗号
     */
    @TableField("qz_no")
    private String qzNo;

    /**
     * 纳税人识别号
     */
    @TableField("ns_id")
    private String nsId;

    /**
     * 联系人
     */
    @TableField("user_name")
    private String userName;
    /**
     * 手机号
     */
    @TableField("phone")
    private String phone;

    /**
     * 邮箱
     */
    @TableField("email")
    private String email;

    /**
     * 公司地址
     */
    @TableField("address")
    private String address;

    /**
     * 备注
     */
    @TableField("remark")
    private String remark;

    /**
     * 插入时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @TableField(value = "insert_date", fill = FieldFill.INSERT)
    private LocalDateTime insertDate;

    /**
     * 更新时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @TableField(value = "update_date", fill = FieldFill.UPDATE)
    private LocalDateTime updateDate;

    /**
     * 插入人
     */
    @TableField(value = "insert_user", fill = FieldFill.INSERT)
    private Integer insertUser;

    /**
     * 更新人
     */
    @TableField(value = "update_user", fill = FieldFill.UPDATE)
    private Integer updateUser;

    /**
     * 有效标识 Y：启用 D：未启用
     */
    @TableField("state")
    private String state;


    public static final String ID = "id";

    public static final String QY_NAME = "qy_name";

    public static final String NS_ID = "ns_id";

    public static final String USER_NAME = "user_name";

    public static final String PHONE = "phone";

    public static final String EMAIL = "email";

    public static final String ADDRESS = "address";

    public static final String REMARK = "remark";

    public static final String INSERT_DATE = "insert_date";

    public static final String UPDATE_DATE = "update_date";

    public static final String INSERT_USER = "insert_user";

    public static final String UPDATE_USER = "update_user";

    public static final String STATE = "state";

    @Override
    public Serializable pkVal() {
        return this.id;
    }
}
