package com.greatchn.collection.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;

@Getter
@Setter
@Accessors(chain = true)
@TableName("sj_file_save_param")
public class SjFileSaveParamPO extends Model<SjFileSaveParamPO> {

    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    @TableField("file_type_id")
    private Integer fileTypeId;

    @TableField("file_key")
    private String fileKey;

    /**
     * 取值方式（系统导入：F，默认值：M）
     */
    @TableField("vv_type")
    private String vvType;


    /**
     * 默认值
     */
    @TableField("vv_value")
    private String vvValue;

    @TableField("xt_id")
    private String xtId;

    /**
     * 插入时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @TableField("insert_date")
    private LocalDateTime insertDate;

    /**
     * 有效标志
     */
    @TableField("state")
    private String state;

    @TableField("remark")
    private String remark;


    public static final String ID = "id";

    public static final String FILE_TYPE_ID = "file_type_id";

    public static final String FILE_KEY = "file_key";

    public static final String VV_TYPE = "vv_type";

    public static final String VV_VALUE = "vv_value";

    public static final String XT_ID = "xt_id";

    public static final String INSERT_DATE = "insert_date";

    public static final String STATE = "state";

    public static final String REMARK = "remark";

    @Override
    public Serializable pkVal() {
        return this.id;
    }

}
