package com.greatchn.collection.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import java.io.Serializable;
import java.time.LocalDateTime;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;
import lombok.experimental.Accessors;

/**
 * <p>
 * 收集主流程记录总表
 * </p>
 *
 * @author mybatis-plus-generator
 * @since 2022-08-02
 */
@Getter
@Setter
@Accessors(chain = true)
@TableName("sj_log")
public class SjLogPO extends Model<SjLogPO> {

    private static final long serialVersionUID = 1L;

    /**
     * 无意义主键
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    @TableField("sj_id")
    private Integer sjId;

    /**
     * 收集记录id	生成规则	收集区间+启动时间+收集id		例：收集区间为年，触发时间一月一日（0101），收集id为1	当前为2022年		生成id为	202201010001
     */
    @TableField("sj_log_id")
    private String sjLogId;

    /**
     * 收集文件总数
     */
    @TableField("sj_cont")
    private Integer sjCont;

    /**
     * 收集成功数量
     */
    @TableField("sj_suss")
    private Integer sjSuss;

    /**
     * 记录结果	01：收集中 （进行中不允许操作该收集流程）	02：收集完成	03：预组卷中（进行中不允许操作该收集流程）	04：预组卷完成	92：收集中存在错误	93：预组卷失败
     */
    @TableField("sj_state")
    private String sjState;

    /**
     * 插入人
     */
    @TableField("insert_user")
    private String insertUser;

    /**
     * 插入时间
     */
    @TableField("insert_date")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private LocalDateTime insertDate;

    /**
     * 更新人
     */
    @TableField("update_user")
    private String updateUser;

    /**
     * 更新时间
     */
    @TableField("update_date")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private LocalDateTime updateDate;

    /**
     * 有效标志
     */
    @TableField("state")
    private String state;


    /**
     * 手动收集对应的文件类型id
     */
    @TableField("manual_file_type")
    private Integer manualFileType;


    /**
     * 手动收集id
     */
    @TableField("manual_id")
    private Integer manualId;

    /**
     * 系统id
     */
    @TableField("xt_id")
    private String xtId;

    /**
     * 系统id
     */
    @TableField("qiye_id")
    private Integer qiyeId;

    /**
     * 组织id
     */
    @TableField("organization_id")
    private Integer organizationId;

    public static final String ID = "id";

    public static final String SJ_ID = "sj_id";

    public static final String SJ_LOG_ID = "sj_log_id";

    public static final String SJ_CONT = "sj_cont";

    public static final String SJ_SUSS = "sj_suss";

    public static final String SJ_STATE = "sj_state";

    public static final String INSERT_USER = "insert_user";

    public static final String INSERT_DATE = "insert_date";

    public static final String UPDATE_USER = "update_user";

    public static final String UPDATE_DATE = "update_date";

    public static final String STATE = "state";

    public static final String MANUAL_FILE_TYPE = "manual_file_type";

    public static final String MANUAL_ID = "manual_id";

    public static final String XT_Id = "xt_id";

    public static final String QIYE_Id = "qiye_id";

    public static final String ORGANIZATUIN_ID = "organization_id";

    @Override
    public Serializable pkVal() {
        return this.id;
    }

}
