package com.greatchn.collection.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import java.io.Serializable;
import java.time.LocalDateTime;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;
import lombok.experimental.Accessors;

/**
 * <p>
 * 收集记录附表2——附件收集记录
 * </p>
 *
 * @author mybatis-plus-generator
 * @since 2022-08-02
 */
@Getter
@Setter
@Accessors(chain = true)
@TableName("sj_log_sub2")
public class SjLogSub2PO extends Model<SjLogSub2PO> {

    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    @TableField("sj_sub1_id")
    private Integer sjSub1Id;

    /**
     * 文件类型
     */
    @TableField("file_type_id")
    private Integer fileTypeId;

    @TableField("dzwjh")
    private String dzwjh;

    /**
     * 全宗号-收集id-顺序号（七位，不够补0 / 来源系统资料唯一标志）	例：QZ001-202101010001-0000001
     */
    @TableField("fj_xh")
    private String fjXh;

    /**
     * 对接系统对文件的唯一标识
     */
    @TableField("xt_uuid")
    private String xtUuid;

    /**
     * 收集状态
     */
    @TableField("sj_state")
    private String sjState;

    /**
     * 插入人
     */
    @TableField("insert_user")
    private String insertUser;

    /**
     * 插入时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @TableField("insert_date")
    private LocalDateTime insertDate;

    /**
     * 更新人
     */
    @TableField("update_user")
    private String updateUser;

    /**
     * 更新时间
     */
    @TableField("update_date")
    private LocalDateTime updateDate;

    /**
     * 有效标志
     */
    @TableField("state")
    private String state;


    public static final String ID = "id";

    public static final String SJ_SUB1_ID = "sj_sub1_id";

    public static final String FILE_TYPE_ID = "file_type_id";

    public static final String DZWJH = "dzwjh";

    public static final String FJ_XH = "fj_xh";

    public static final String XT_UUID = "xt_uuid";

    public static final String SJ_STATE = "sj_state";

    public static final String INSERT_USER = "insert_user";

    public static final String INSERT_DATE = "insert_date";

    public static final String UPDATE_USER = "update_user";

    public static final String UPDATE_DATE = "update_date";

    public static final String STATE = "state";

    @Override
    public Serializable pkVal() {
        return this.id;
    }

}
