package com.greatchn.collection.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;

@Getter
@Setter
@Accessors(chain = true)
@TableName("sj_md_xt")
public class SjMdXtPO extends Model<SjMdXtPO> {

    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 系统id
     */
    @TableField("xt_id")
    private String xtId;

    /**
     * 文件类型id
     */
    @TableField("file_type_id")
    private Integer fileTypeId;

    /**
     * 元数据id
     */
    @TableField("md_id")
    private String mdId;

    /**
     * 对接内容
     */
    @TableField("xt_value")
    private String xtValue;

    /**
     * 备注
     */
    @TableField("xt_rem")
    private String xtRem;

    /**
     * 对接标志	M：系统默认值或配置值	F：对接系统字段名（可手动修改）	T：特殊处理字段（可手动修改）	S：系统规则生成字段
     */
    @TableField("xt_state")
    private String xtState;

    /**
     * 插入时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @TableField("insert_date")
    private LocalDateTime insertDate;

    /**
     * 有效标志
     */
    @TableField("state")
    private String state;


    public static final String ID = "id";

    public static final String XT_ID = "xt_id";

    public static final String FILE_TYPE_ID = "file_type_id";

    public static final String MD_ID = "md_id";

    public static final String XT_VALUE = "xt_value";

    public static final String XT_REM = "xt_rem";

    public static final String XT_STATE = "xt_state";

    public static final String INSERT_DATE = "insert_date";

    public static final String STATE = "state";

    @Override
    public Serializable pkVal() {
        return this.id;
    }
}
