package com.greatchn.collection.constant;

import java.nio.charset.StandardCharsets;

/**
 * 权限相关常量
 *
 * @author wanghaohui
 * @date 2022/06/21
 */
public final class AuthConstant {

    private AuthConstant() {
    }

    /**
     * jwt 加密key
     */
    public static final byte[] JWT_ENCRYPT_KEY = "*Jd5UNGCgTW$rejU7CLhZlUg$d11qOKq1xiexdjnFJjmJdSO%h1In7Aw&Wha7*eUgf$X3D9bANAGxOR3v@1SnJxf*e4YirvMFb2".getBytes(StandardCharsets.UTF_8);
    /**
     * jwt 企业id key
     */
    public static final String JWT_CUSTOMER_ID_KEY = "customerId";
    /**
     * jwt 企业员工id key
     */
    public static final String JWT_EMPLOYEE_ID_KEY = "employeeId";
    /**
     * jwt 企业账套id key
     */
    public static final String JWT_ACCOUNT_ID_KEY = "accountId";
    /**
     * jwt 内部员工id key
     */
    public static final String JWT_OPERATOR_ID_KEY = "operatorId";
    /**
     * jwt 创建时间 key
     */
    public static final String JWT_EXPIRE = "expire";

    /**
     * 请求头中token key (运维人员登录)
     */
    public static final String HEADERS_OPERATOR_TOKEN_KEY = "operatorToken";
    /**
     * 请求头中token key (企业员工登录)
     */
    public static final String HEADERS_EMPLOYEE_TOKEN_KEY = "employeeToken";
    /**
     * 请求头中token key (企业登录)
     */
    public static final String HEADERS_CUSTOMER_TOKEN_KEY = "customerToken";
    /**
     * 请求头中token key (对外接口)
     */
    public static final String HEADERS_OUTSIDE_TOKEN_KEY = "outSideToken";
}
