package com.greatchn.collection.framework.constant;

/**
 * @description 日志常量定义
 * @author duhang
 * @date 2021/7/11
 */
public final class LogConstant {

    private LogConstant() {}

    /**
     * 调用记录id
     */
    public static final String TRACE_ID = "traceId";
    /**
     * 服务名称
     */
    public static final String SERVER_NAME = "appName";
    /**
     * 服务版本
     */
    public static final String SERVER_VERSION = "appVersion";
    /**
     * 用户id
     */
    public static final String USER_ID = "userId";
    /**
     * 请求方式 http:post/http:get等等等等
     */
    public static final String REQ_TYPE = "reqType";
    /**
     * 请求api方法名
     */
    public static final String METHOD_NAME = "methodName";
    /**
     * 请求头
     */
    public static final String REQ_HEADER = "reqHeader";
    /**
     * 请求参数-明文
     */
    public static final String REQ_PARAM = "reqParam";
    /**
     * 请求参数-密文
     */
    public static final String REQ_PARAM_ENCODE = "reqParamEncode";
    /**
     * 请求地址
     */
    public static final String REQ_URL = "reqUrl";
    /**
     * 响应数据-明文
     */
    public static final String RESP_BODY = "respBody";
    /**
     * 响应数据-加密后
     */
    public static final String RESP_BODY_ENCODE = "respBodyEncode";
    /**
     * 异常消息
     */
    public static final String ERR_MESSAGE = "errMessage";
    /**
     * 异常堆栈
     */
    public static final String STACK = "stack";
    /**
     * 请求方ip
     */
    public static final String CLIENT_IP = "clientIp";
    /**
     * 请求方客户端信息
     */
    public static final String CLIENT_INFO = "clientInfo";
    /**
     * 请求方浏览器信息
     */
    public static final String BROWSER_INFO = "browserInfo";

    /**
     * 请求方浏览器信息
     */
    public static final String TEMP_PATH = "/temp";
}
