package com.greatchn.collection.framework.constant;

import lombok.AllArgsConstructor;
import lombok.Getter;
import org.apache.commons.lang3.StringUtils;

import java.time.format.DateTimeFormatter;

public class ManageConstant {
    //全宗号(获取当前全宗)
    public static final String M009 = "M009";
    //机构代码(获取当前全宗)
    public static final String M078 = "M078";

    //电子文件号（根据规则生成）
    public static final String M007 = "M007";

    //文档序号(按顺序生成，主件为001)
    public static final String M019 = "M019";

    //来源（对接系统id）
    public static final String M050 = "M050";

    //当前位置(文件存储位置)
    public static final String M066 = "M066";

    //年度（M033所在年度）
    public static final String M011 = "M011";

    //file_type_id
    public static final String M014 = "M014";

    //月度：取M033的月
    public static final String MZ01 = "MZ01";

    //立档单位名称
    public static final String M006 = "M006";
    // 全宗名称
    public static final String M005 = "M005";

    //题名
    public static final String M022 = "M022";

    //页数
    public static final String M043 = "M043";

    //审批：同意
    public static final String AGREE = "agree";

    //审批：拒绝
    public static final String REFUSE = "refuse";

    // 文件类型权限
    // 菜单
    public static final String MENU_ROLE_M = "M";
    // 文件
    public static final String MENU_ROLE_F = "F";
    // 附件
    public static final String MENU_ROLE_A = "A";

    //sp_pz_rw_info任务类型GD
    public static final String GD_TYPE = "GD";

    //sp_pz_rw_info任务类型JY
    public static final String JY_TYPE = "JY";

    public static final DateTimeFormatter DATE_FORMAT = DateTimeFormatter.ofPattern("yyyy-MM-dd");

    public static final String FILED_ARC_SQL = " arc.dh," +
            " arc.gd_state," +
            " arc.M005," +
            " arc.M009," +
            " arc.M078," +
            " arc.M010," +
            " arc.M011," +
            " arc.M012," +
            " arc.M014," +
            " arc.M016," +
            " arc.M022," +
            " arc.M032," +
            " arc.M038," +
            " arc.M039," +
            " arc.M042," +
            " arc.M043," +
            " arc.MZ01," +
            " arc.state," +
            " arc.formal_dh," +
            " arc.qy_id," +
            " arc.organization_id," +
            " DATE_FORMAT(arc.gd_time,'%Y-%m-%d') AS gd_time," +
            " arc.gd_user," +
            " DATE_FORMAT(arc.lj_time,'%Y-%m-%d') AS lj_time," +
            " arc.lj_user";
    /**
     * 收集状态
     */
    @Getter
    @AllArgsConstructor
    public enum CommonStateEnum {

        COLIN("01", "收集中"),
        COLEND("02", "收集完成"),
        PREIN("03", "预组卷中"),
        PREEND("04", "预组卷完成"),
        COLAIL("92", "收集中存在错误"),
        PREFAIL("93", "预组卷失败");

        private String code;
        private String define;

        public static String getDefineByCode(String code) {
            if (StringUtils.isNotBlank(code)) {
                for (ManageConstant.CommonStateEnum c : ManageConstant.CommonStateEnum.values()) {
                    if (c.getCode().equals(code)) {
                        return c.getDefine();
                    }
                }
            }
            return null;
        }
    }


    /**
     * 流程审批类型
     */
    @Getter
    @AllArgsConstructor
    public enum LcTypeEnum {

        ONESELF("0","本人"),
        INDEPENDENT("1", "独立审批"),
        UNION("2", "联合审批"),
        ANY("3", "任一审批");

        private String code;
        private String define;

        public static String getDefineByCode(String code) {
            if (StringUtils.isNotBlank(code)) {
                for (ManageConstant.LcTypeEnum c : ManageConstant.LcTypeEnum.values()) {
                    if (c.getCode().equals(code)) {
                        return c.getDefine();
                    }
                }
            }
            return null;
        }
    }

    /**
     * 任务类型
     */
    @Getter
    @AllArgsConstructor
    public enum RwTypeEnum {

        JY("JY","借阅"),
        GD("GD", "归档");
        private String code;
        private String define;

        public static String getDefineByCode(String code) {
            if (StringUtils.isNotBlank(code)) {
                for (ManageConstant.RwTypeEnum c : ManageConstant.RwTypeEnum.values()) {
                    if (c.getCode().equals(code)) {
                        return c.getDefine();
                    }
                }
            }
            return null;
        }
    }
}
