package com.greatchn.collection.framework.constant;

import lombok.Getter;
import lombok.experimental.Accessors;

/**
 * 通用响应报文状态枚举
 * <p>
 * Created by duhang on 2019/8/23 9:05
 */
@Getter
@Accessors(fluent = true)
public enum ReturnMsgEnum {

    OK(200, "请求成功"),
    FAIL(400, "请求失败"),
    NOT_FOUND(404, "请求的资源不存在"),
    ERROR(500, "服务器异常"),
    SESSION_TIMEOUT(-1, "未授权或授权信息超时"),
    IDEMPOTENT(-2, "请勿重复操作"),
    API_DISABLE(-3, "接口维护中"),
    SIGN_FAIL(-4, "验签失败");

    private Integer code;
    private String msg;

    private ReturnMsgEnum() {}
    private ReturnMsgEnum(Integer code, String msg) {
        this.code = code;
        this.msg = msg;
    }

    public static String getMsg(Integer code) {
        if (null != code) {
            for (ReturnMsgEnum r : ReturnMsgEnum.values()) {
                if (r.code().equals(code)) {
                    return r.msg();
                }
            }
        }
        return null;
    }
}
