package com.greatchn.collection.framework.exception;

import lombok.Getter;

/**
 * 断言异常
 *
 * @author duhang
 * @date 2022/4/4
 */
@Getter
public class AssertException extends RuntimeException {

    private static final long serialVersionUID = -4518190765300115697L;

    private Integer code;

    private Object data;

    public AssertException() {}

    public AssertException(String message) {
        super(message);
    }

    public AssertException(Throwable cause) {
        super(cause);
    }

    public AssertException(String message, Throwable cause) {
        super(message, cause);
    }

    public AssertException(String message, Throwable cause, boolean enableSuppression, boolean writableStackTrace) {
        super(message, cause, enableSuppression, writableStackTrace);
    }

    public AssertException(Integer code) {
        this.code = code;
    }

    public AssertException(Integer code, String message) {
        super(message);
        this.code = code;
    }

    public AssertException(Integer code, Throwable cause) {
        super(cause);
        this.code = code;
    }

    public AssertException(Integer code, String message, Throwable cause) {
        super(message, cause);
        this.code = code;
    }

    public AssertException(Integer code, String message, Throwable cause, boolean enableSuppression, boolean writableStackTrace) {
        super(message, cause, enableSuppression, writableStackTrace);
        this.code = code;
    }

    /**
     *  构造程序业务错误信息
     */
    public AssertException(Integer code, String message, Object data) {
        super(message);
        this.code = code;
        this.data = data;
    }
}
