package com.greatchn.collection.framework.util;

import java.io.*;
import org.apache.commons.codec.binary.Base64;

public class CommonUtil {
    public static String getPdfFilePath(String filePath) {
        String fileType = filePath.substring(filePath.lastIndexOf(".") + 1, filePath.length());
        return filePath.replace(fileType, "pdf");
    }

    /**
     * @Description: 文件转为base64字符串。filePath：文件路径
     * @Param: [filePath]
     * @return: java.lang.String
     */
    public static String fileToBase64(String filePath) {
        File file = new File(filePath);
        FileInputStream inputFile = null;
        byte[] buffer = null;
        try {
            inputFile = new FileInputStream(file);
            buffer = new byte[(int) file.length()];
            inputFile.read(buffer);
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (null != inputFile) {
                try {
                    inputFile.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
        byte[] bs = Base64.encodeBase64(buffer);
        return new String(bs);
    }

    /**
     * base64字符串转文件
     * @param base64Str
     * @param targetFilePath
     * @return
     */
    public static void base64ToFile(String base64Str, String targetFilePath) {
        byte[] buffer = Base64.decodeBase64(base64Str);
        FileOutputStream out = null;
        try {
            out = new FileOutputStream(targetFilePath);
            out.write(buffer);
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            if (null != out) {
                try {
                    out.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
    }
}
