package com.greatchn.collection.framework.vo;

import com.fasterxml.jackson.annotation.JsonAutoDetect;
import com.greatchn.collection.framework.constant.LogConstant;
import com.greatchn.collection.framework.constant.ReturnMsgEnum;
//import com.greatchn.orm.util.IdGenerator;
import lombok.Data;
import lombok.experimental.Accessors;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.MDC;

import java.io.Serializable;

/**
 * 响应报文vo
 * <p>
 * Created by duhang on 2019/8/16 15:51
 */
@Data
@Accessors(chain = true)
@JsonAutoDetect(fieldVisibility = JsonAutoDetect.Visibility.ANY, getterVisibility = JsonAutoDetect.Visibility.NONE)
public class ReturnMsgVO<T> implements Serializable {

    private static final long serialVersionUID = 6809182479486896964L;

    /**
     * 响应代码
     */
    private Integer code;
    /**
     * 响应消息
     */
    private String msg;
    /**
     * 响应数据
     */
    private T data;

//    private String traceId = StringUtils.isNotBlank(MDC.get(LogConstant.TRACE_ID)) ? MDC.get(LogConstant.TRACE_ID) : IdGenerator.newID();

    private ReturnMsgVO() {}

    public static ReturnMsgVO newInstance() {
        return new ReturnMsgVO();
    }

    public static ReturnMsgVO ok() {
        return ReturnMsgVO.newInstance().setCode(ReturnMsgEnum.OK.code()).setMsg(ReturnMsgEnum.OK.msg());
    }

    public static ReturnMsgVO fail() {
        return ReturnMsgVO.newInstance().setCode(ReturnMsgEnum.FAIL.code()).setMsg(ReturnMsgEnum.FAIL.msg());
    }

    public static ReturnMsgVO error() {
        return ReturnMsgVO.newInstance().setCode(ReturnMsgEnum.ERROR.code()).setMsg(ReturnMsgEnum.ERROR.msg());
    }

    public static ReturnMsgVO sessionTimeout() {
        return ReturnMsgVO.newInstance().setCode(ReturnMsgEnum.SESSION_TIMEOUT.code()).setMsg(ReturnMsgEnum.SESSION_TIMEOUT.msg());
    }

    public static ReturnMsgVO idempotentRequired() {
        return ReturnMsgVO.newInstance().setCode(ReturnMsgEnum.IDEMPOTENT.code()).setMsg(ReturnMsgEnum.IDEMPOTENT.msg());
    }

}
