package com.greatchn.collection.job;

import com.greatchn.collection.service.CollectService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.annotation.Scheduled;

@Slf4j
@Configuration
public class CollectJob {

    @Autowired
    CollectService collectService;

    /**
     * 对账消息推送定时器
     * 每一小时运行一次
     */
    @Scheduled(cron = "0 0/1 * * * ? ")
    public void send() throws Exception {
        log.info("收集文件开始");
        collectService.startCollectJob();
        log.info("收集文件结束");
    }
}
