package com.greatchn.collection.service;

import cn.hutool.json.JSONArray;
import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.CollectionUtils;
import com.greatchn.collection.framework.constant.ManageConstant;
import com.greatchn.collection.framework.exception.AssertException;
import com.greatchn.collection.framework.util.AposePdfUtil;
import com.greatchn.collection.framework.util.CommonUtil;
import com.greatchn.collection.framework.util.HttpUtil;
import com.greatchn.collection.entity.*;
import com.greatchn.collection.framework.util.AssertUtil;
import com.greatchn.collection.entity.*;
import com.greatchn.collection.vo.CcFileInfoVO;
import com.lowagie.text.pdf.PdfReader;
import org.apache.commons.io.FileUtils;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.Base64Utils;

import java.io.*;
import java.math.BigDecimal;
import java.nio.charset.StandardCharsets;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.*;
import java.util.stream.Collectors;

@Service
public class CollectService {
    // 设置图片上传路径
    @Value("${file.basepath}")
    private String basePath;

    @Autowired
    private SjLogMapper sjLogMapper;

    @Autowired
    private SjFileAttRelMapper sjFileAttRelMapper;
    @Autowired
    private SjFileSaveParamMapper sjFileSaveParamMapper;
    @Autowired
    private SjMdXtMapper sjMdXtMapper;

    @Autowired
    private SjLogSub1Mapper sjLogSub1Mapper;

    @Autowired
    private SjLogSub1InfoMapper sjLogSub1InfoMapper;

    @Autowired
    private SjLogSub2Mapper sjLogSub2Mapper;

    @Autowired
    private SjLogSub2InfoMapper sjLogSub2InfoMapper;

    @Autowired
    private GxFileAttMapper gxFileAttMapper;

    @Autowired
    private CcFileInfoMapper ccFileInfoMapper;

    @Autowired
    private ErmsQiyeMapper ermsQiyeMapper;

    @Autowired
    private ErmsOrganizationMapper ermsOrganizationMapper;

    @Autowired
    private ErmsFileTypeMapper ermsFileTypeMapper;

    @Autowired
    private CcFileSaveInfoMapper ccFileSaveInfoMapper;

    @Autowired
    private SjLogErrorMapper sjLogErrorMapper;

    @Autowired
    ErmsQzCertMapper ermsQzCertMapper;

    @Autowired
    FileService fileService;

    @Autowired
    PzFileSjMapper pzFileSjMapper;

    public static final DateTimeFormatter DATEFORMAT = DateTimeFormatter.ofPattern("yyyyMMdd");

    @Transactional(rollbackFor = Exception.class)
    public void collect(String xtId, Integer organizationId, Integer fileTypeId, String userId) throws Exception {
        LocalDate dd = LocalDate.now();
        String startNumber = dd.format(DATEFORMAT);
        Integer tt = sjLogMapper.getNumber(startNumber);
        String sjLogVarId = xtId + startNumber + StringUtils.leftPad(tt.toString(), 4, "0");

        JSONObject jsonObject= new JSONObject();
        jsonObject.set("xtId", xtId);
        jsonObject.set("fileTypeId", fileTypeId+"");
        Map mm = new HashMap();
        mm.put("ztdm", "40281f8186a187500186c566f1b20023");
        mm.put("flag", "month");
        mm.put("month", "202303");
        jsonObject.set("param", mm);

        List<Map<String, String>> demoList = this.getUrlFile(jsonObject);

        int wjCount = demoList.size();

        SjLogPO sjLogPO = new SjLogPO();
        sjLogPO.setSjLogId(sjLogVarId);
        sjLogPO.setState("Y");
        sjLogPO.setSjCont(wjCount);
        sjLogPO.setInsertUser(userId);
        sjLogPO.setInsertDate(LocalDateTime.now());
        sjLogPO.setManualFileType(fileTypeId);
        sjLogPO.setManualId(1);
        sjLogPO.setXtId(xtId);
        sjLogPO.setOrganizationId(organizationId);
        sjLogPO.setSjSuss(0);
        sjLogPO.setSjState(ManageConstant.CommonStateEnum.COLIN.getCode());
        sjLogMapper.insert(sjLogPO);

        List<SjLogSub1InfoPO> sjLogInfoPOList = new ArrayList<>();

        for (int i = 1; i <= wjCount; i++) {
            Map<String, String> demo = demoList.get(i);
            SjLogSub1PO sjLogSub1PO = new SjLogSub1PO();
            sjLogSub1PO.setSjLogId(sjLogPO.getId());
            sjLogSub1PO.setFileTypeId(fileTypeId);
            //全宗号-收集id-顺序号（七位，不够补0 / 来源系统资料唯一标志） 例：QZ001-202101010001-0000001
            sjLogSub1PO.setDzwjh(sjLogPO.getSjLogId() + "_" + StringUtils.leftPad(String.valueOf(i + 1), 7, "0"));
            sjLogSub1PO.setXtUuid(UUID.randomUUID().toString().replaceAll("-", ""));
            sjLogSub1PO.setSjState(ManageConstant.CommonStateEnum.COLIN.getCode());
            sjLogSub1PO.setInsertUser(userId);
            sjLogSub1PO.setInsertDate(LocalDateTime.now());
            sjLogSub1PO.setState("Y");
            sjLogSub1Mapper.insert(sjLogSub1PO);

            Integer sjLogSub1Id = sjLogSub1PO.getId();

            for(Map.Entry<String,String> entry:demo.entrySet()) {
                SjLogSub1InfoPO sjLogSub1InfoPO = new SjLogSub1InfoPO();
                sjLogSub1InfoPO.setSjLogSub1Id(sjLogSub1Id);
                sjLogSub1InfoPO.setInfoKey(entry.getKey());
                sjLogSub1InfoPO.setInfoValue(String.valueOf(entry.getValue()));
                sjLogSub1InfoPO.setState(ManageConstant.CommonStateEnum.COLIN.getCode());

                sjLogSub1InfoMapper.insert(sjLogSub1InfoPO);
            }

            // 获取附件类型列表
            QueryWrapper example = new QueryWrapper();
            example.eq("xt_id", xtId);
            example.eq("file_id", fileTypeId);
            example.eq("state", "Y");
            List<SjFileAttRelPO> sjFileAttRelPOList = sjFileAttRelMapper.selectList(example);
            int fjXh = 1;
            for(SjFileAttRelPO rel : sjFileAttRelPOList){
                int count = collectAtt(sjLogSub1PO, xtId, fileTypeId, rel.getAttId(), demo, fjXh);
                fjXh = fjXh + count;
            }
        }
    }

    public int collectAtt(SjLogSub1PO sjLogSub1PO, String xtId, Integer fileTypeId, Integer attId, Map<String, String> demo, int fjXh) throws Exception {
        int result = 0;

        //得到数据
        //调用外部接口 传递一些参数
        JSONObject wjObject = new JSONObject();
        wjObject.set("xtId", xtId);
        wjObject.set("fileTypeId", attId + "");
        wjObject.set("fileParTypeId", fileTypeId + "");

        QueryWrapper paramExam = new QueryWrapper();
        paramExam.eq("xt_id", xtId);
        paramExam.eq("file_type_id", attId);
        paramExam.eq("state", "Y");
        List<SjFileSaveParamPO> sjFileSaveParamPOs = sjFileSaveParamMapper.selectList(paramExam);
        Map fjMap = new HashMap();
        for (SjFileSaveParamPO sjFileSaveParamPO : sjFileSaveParamPOs) {
            fjMap.put(sjFileSaveParamPO.getFileKey(), demo.get(sjFileSaveParamPO.getFileKey()));
        }
        wjObject.set("param", fjMap);

        //查询附件
        List<Map<String, String>> qsFpInfoPODemoList = getUrlFile(wjObject);

        result = qsFpInfoPODemoList.size();

        for (int k = 0; k < result; k++) {
            Map<String, String> fjDemo = qsFpInfoPODemoList.get(k);

            SjLogSub2PO sjLogSub2PO = new SjLogSub2PO();
            sjLogSub2PO.setSjSub1Id(sjLogSub1PO.getId());
            sjLogSub2PO.setFileTypeId(attId);
            sjLogSub2PO.setDzwjh(sjLogSub1PO.getDzwjh() + "_" + StringUtils.leftPad(String.valueOf(fjXh + k), 4, "0")); //附件电子文件号=主电子文件号+附件序号
            sjLogSub2PO.setFjXh(fjXh + k +"");//如果存在附件 附件序号从2开始
            sjLogSub2PO.setXtUuid(UUID.randomUUID().toString().replaceAll("-", ""));
            sjLogSub2PO.setSjState(ManageConstant.CommonStateEnum.COLIN.getCode());
            sjLogSub2PO.setInsertUser(sjLogSub1PO.getInsertUser());
            sjLogSub2PO.setInsertDate(LocalDateTime.now());
            sjLogSub2PO.setState("Y");
            sjLogSub2Mapper.insert(sjLogSub2PO);

            Integer sjLogSub2Id = sjLogSub2PO.getId();

            for(Map.Entry<String,String> entry:fjDemo.entrySet()) {
                SjLogSub2InfoPO sjLogSub2InfoPO = new SjLogSub2InfoPO();
                sjLogSub2InfoPO.setSjLogSub2Id(sjLogSub2Id);
                sjLogSub2InfoPO.setInfoKey(entry.getKey());
                sjLogSub2InfoPO.setInfoValue(entry.getValue());
                sjLogSub2InfoPO.setState(ManageConstant.CommonStateEnum.COLIN.getCode());

                sjLogSub2InfoMapper.insert(sjLogSub2InfoPO);
            }

            //保存文件附件关系到表（gx_file_att）
            GxFileAttPO gxFileAttPO = new GxFileAttPO();
            gxFileAttPO.setFileTypeId(fileTypeId);
            gxFileAttPO.setFileDzwjh(sjLogSub1PO.getXtUuid());
            gxFileAttPO.setAttDzwjh(sjLogSub2PO.getXtUuid());
            gxFileAttPO.setAttTypeId(attId);
            gxFileAttPO.setState("Y");
            gxFileAttMapper.insert(gxFileAttPO);
        }

        return result;
    }

    public List getUrlFile(JSONObject jsonObject) throws Exception {//调用外部接口 传递一些参数
        String res = HttpUtil.openHttpByPost("http://192.168.106.150:39091/" + "sjCollection/sjInfo", jsonObject.toString());
        AssertUtil.hasText(res, "数据不存在");
        JSONObject jsonRes = JSONUtil.parseObj(res);
        Integer status = (Integer) jsonRes.get("status");
        AssertUtil.isTrue(200 == status, "发生异常");
        List demoLists = jsonRes.get("data", List.class);
        return demoLists;
    }

    public void startCollectJob(){
        QueryWrapper sjLogExam = new QueryWrapper();
        sjLogExam.eq("sj_state", ManageConstant.CommonStateEnum.COLIN.getCode());
        List<SjLogPO> logList = sjLogMapper.selectList(sjLogExam);

        for(SjLogPO sjLog : logList) {
            Integer sjLogId = sjLog.getId();
            QueryWrapper sjLogSub1Exam = new QueryWrapper();
            sjLogSub1Exam.ne("sj_state", ManageConstant.CommonStateEnum.COLEND.getCode());
            sjLogSub1Exam.eq("state","Y");
            sjLogSub1Exam.eq("sj_log_id",sjLogId);
            List<SjLogSub1PO> logSub1List = sjLogSub1Mapper.selectList(sjLogSub1Exam);
            ErmsOrganizationPO ermsOrganizationPO = ermsOrganizationMapper.selectById(sjLog.getOrganizationId());
            ErmsQiyePO ermsQiyePO = ermsQiyeMapper.getErmsQzCertPOByOgId(sjLog.getOrganizationId());

            int xh = 0;

            for(SjLogSub1PO sjLogSub1 : logSub1List) {
                Integer sub1Id = sjLogSub1.getId();
                QueryWrapper sub1InfoExam = new QueryWrapper();
                sub1InfoExam.eq("state", ManageConstant.CommonStateEnum.COLIN.getCode());
                sub1InfoExam.eq("sj_log_sub1_id", sub1Id);
                List<SjLogSub1InfoPO> sjLogInfoPOList = sjLogSub1InfoMapper.selectList(sub1InfoExam);
                List<Integer> lineList = sjLogInfoPOList.stream().map(e -> e.getSjLogSub1Id()).distinct().collect(Collectors.toList());
                xh++;
                Integer sjLogSub1Id = sjLogSub1.getId();
                collectbySub1ById(sjLogSub1,ermsQiyePO, ermsOrganizationPO, sjLogInfoPOList, xh, sjLog.getXtId());
                if(ManageConstant.CommonStateEnum.COLIN.getCode().equals(sjLogSub1.getSjState())){
                    sjLogSub1InfoMapper.updateState(sub1Id, ManageConstant.CommonStateEnum.COLEND.getCode());
                }
            }
            //更新sjLog
            long successCount = sjLogSub1Mapper.countSjState(sjLogId, " and sj_state = '" + ManageConstant.CommonStateEnum.COLEND.getCode() + "'");
            sjLog.setSjSuss((int)successCount);
            if (0 == sjLogSub1Mapper.countSjState(sjLogId, " and sj_state != '" + ManageConstant.CommonStateEnum.COLEND.getCode() + "'")) {
                sjLog.setSjState(ManageConstant.CommonStateEnum.COLEND.getCode());
            }else{
                sjLog.setSjState(ManageConstant.CommonStateEnum.COLAIL.getCode());
            }

            sjLogMapper.updateById(sjLog);
        }
    }

    /*
     * 采集sjLogSub1
     * */
    public void collectbySub1ById(SjLogSub1PO sjLogSub1, ErmsQiyePO ermsQiyePO, ErmsOrganizationPO ermsOrganizationPO, List<SjLogSub1InfoPO> sjLogInfoPOList, Integer xh, String xtId){
        Integer sub1Id = sjLogSub1.getId();
        Integer fileTypeId = sjLogSub1.getFileTypeId();

        Map<String, String> map = sjLogInfoPOList.stream().collect(Collectors.toMap(SjLogSub1InfoPO::getInfoKey, SjLogSub1InfoPO::getInfoValue));
        //保存sub1的信息及文件
        saveCcFileInfo(xtId, fileTypeId, ermsQiyePO, ermsOrganizationPO, map, xh, sjLogSub1, null);

        QueryWrapper sub2Exam = new QueryWrapper();
        sub2Exam.eq("sj_sub1_id",sub1Id);
        sub2Exam.eq("sj_state", ManageConstant.CommonStateEnum.COLIN.getCode());
        List<SjLogSub2PO> sjLogSub2List = sjLogSub2Mapper.selectList(sub2Exam);

        int fjxh = 0;
        //保存sub1下所有sub2的信息及文件
        for(SjLogSub2PO sub2Po: sjLogSub2List){
            fjxh++;
            Integer sub2Id = sub2Po.getId();

            QueryWrapper sub2InfoExam = new QueryWrapper();
            sub2InfoExam.eq("sj_sub2_id", sub2Id);
            sub2InfoExam.eq("state", ManageConstant.CommonStateEnum.COLIN.getCode());
            List<SjLogSub2InfoPO> sjLogSub2InfoPOList = sjLogSub2InfoMapper.selectList(sub2InfoExam);

            collectbySub2ById(xtId, ermsQiyePO, ermsOrganizationPO, sjLogSub2InfoPOList, fjxh, sjLogSub1);
        }
        //更新sub1状态
        if(0 == sjLogSub2Mapper.countSjState(sub1Id, " and sj_state != '" +ManageConstant.CommonStateEnum.COLEND.getCode()+"'")){
            sjLogSub1.setSjState(ManageConstant.CommonStateEnum.COLEND.getCode());
        }else{
            sjLogSub1.setSjState(ManageConstant.CommonStateEnum.COLAIL.getCode());
        }
        sjLogSub1Mapper.updateById(sjLogSub1);
    }

    /*
     * 采集sjLogSub2
     * */
    public void collectbySub2ById(String xtId, ErmsQiyePO ermsQiyePO, ErmsOrganizationPO ermsOrganizationPO, List<SjLogSub2InfoPO> sjLogInfoPOList, Integer xh, SjLogSub1PO sjLogSub1){
        Integer sub2Id = sjLogInfoPOList.get(0).getSjLogSub2Id();
        SjLogSub2PO sjLogSub2 = sjLogSub2Mapper.selectById(sub2Id);
        Integer fileTypeId = sjLogSub2.getFileTypeId();
        Map<String, String> map = sjLogInfoPOList.stream().collect(Collectors.toMap(SjLogSub2InfoPO::getInfoKey, SjLogSub2InfoPO::getInfoValue));
        //保存sub2的信息及文件
        saveCcFileInfo(xtId, fileTypeId, ermsQiyePO, ermsOrganizationPO, map, xh, sjLogSub1, sjLogSub2 );
    }

    /*
     * 保存文件信息
     * */
    public void saveCcFileInfo(String xtId, Integer fileTypeId, ErmsQiyePO ermsQiyePO, ErmsOrganizationPO ermsOrganizationPO, Map<String,String> map, Integer xh, SjLogSub1PO sjLogSub1PO, SjLogSub2PO sjLogSub2PO){
        String uuid="";
        String dzwjh="";

        if(sjLogSub2PO == null){
            uuid = sjLogSub1PO.getXtUuid();
            dzwjh = sjLogSub1PO.getDzwjh();
        }else{
            uuid = sjLogSub2PO.getXtUuid();
            dzwjh = sjLogSub2PO.getDzwjh();
        }

        long count = ccFileInfoMapper.count(fileTypeId, " where dzwjh = '" + uuid + "'" );
        String checkSql = "";
        QueryWrapper exam = new QueryWrapper();
        exam.eq("xt_id", xtId);
        exam.eq("file_type_id", fileTypeId);
        exam.eq("state", "Y");

        //元数据类别
        List<SjMdXtPO> mdXtPOList = sjMdXtMapper.selectList(exam);
        if(count == 0) {
            List<PzFileSjPO> pzFileSjList = pzFileSjMapper.selectList(new QueryWrapper<PzFileSjPO>().eq("file_type_id", fileTypeId).eq("state", "Y"));

            StringBuilder sqlFjOne = new StringBuilder();
            StringBuilder sqlFjTwo = new StringBuilder();

            sqlFjOne.append("(dzwjh");
            sqlFjTwo.append("('" + uuid + "'");
            String temp = "";

            // 处理附件元数据
            if (CollectionUtils.isNotEmpty(mdXtPOList)) {
                for (SjMdXtPO mdXtPO : mdXtPOList) {
                    String xtState = mdXtPO.getXtState();
                    if ("M".equals(xtState)) {
                        //M：系统默认值或配置值
                        sqlFjOne.append("," + mdXtPO.getMdId());
                        sqlFjTwo.append(",'" + mdXtPO.getXtValue() + "'");
                    } else if ("F".equals(xtState)) {
                        // F：对接系统字段名（可手动修改）
                        sqlFjOne.append("," + mdXtPO.getMdId());
                        String xtValue = mdXtPO.getXtValue();
                        sqlFjTwo.append(",'" + map.get(xtValue) + "'");

                    } else { // 其他标志一律按照特殊操作处理
                        if (!ManageConstant.M043.equals(mdXtPO.getMdId()) || !ManageConstant.M043.equals(mdXtPO.getMdId())) {
                            sqlFjOne.append("," + mdXtPO.getMdId());
                        }

                        if (ManageConstant.M006.equals(mdXtPO.getMdId()) || ManageConstant.M005.equals(mdXtPO.getMdId())) {
                            temp =  ermsOrganizationPO.getOrganizationName() ;
                        } else if (ManageConstant.M007.equals(mdXtPO.getMdId())) {
                            temp =  dzwjh ;//附件的M007存主键的dzwjh
                        } else if (ManageConstant.M009.equals(mdXtPO.getMdId())) {
                            temp =  ermsQiyePO.getQzNo() ;
                        } else if (ManageConstant.M011.equals(mdXtPO.getMdId())) {
                            SjMdXtPO sjmdDemo = sjMdXtMapper.getOne(xtId, fileTypeId, "M033");
                            temp =  map.get(sjmdDemo.getXtValue()).toString().substring(0, 4) ;
                        } else if (ManageConstant.M014.equals(mdXtPO.getMdId())) {
                            temp =  fileTypeId + "";
                        } else if (ManageConstant.MZ01.equals(mdXtPO.getMdId())) {
                            SjMdXtPO sjmdDemo = sjMdXtMapper.getOne(xtId, fileTypeId, "M033");
                            String date = map.get(sjmdDemo.getXtValue()).toString();
                            if (date.length() == 8 || date.length() == 6) {//20220101 222201
                                temp =  date.substring(4, 6) ;
                            } else if (date.length() == 4) {//2022
                                temp = "";
                            } else {//2022-01-01
                                temp = date.substring(5, 7);
                            }
                        } else if (ManageConstant.M019.equals(mdXtPO.getMdId())) {
                            temp =  xh +"";
                        } else if (ManageConstant.M050.equals(mdXtPO.getMdId())) {
                            temp =  xtId ;
                        } else if (ManageConstant.M022.equals(mdXtPO.getMdId())) {
                            ErmsFileTypePO ermsFileTypePO = ermsFileTypeMapper.selectById(mdXtPO.getFileTypeId());
                            temp = ermsFileTypePO.getFileTypeName() ;
                        } else if (ManageConstant.M078.equals(mdXtPO.getMdId())) {
                            temp = ermsOrganizationPO.getOrganizationNo();
                        } else {
                            if (!ManageConstant.M043.equals(mdXtPO.getMdId())) {
                                String xtValue = ""; // 特殊方法
                                temp = xtValue;
                            }
                        }
                    }
                    sqlFjTwo.append(",'" + temp + "'");

                    long ifHave = pzFileSjList.stream().filter(item->mdXtPO.getMdId().equals(item.getMdId())).count();

                    if(ifHave != 0) {
                        checkSql += " AND " + mdXtPO.getMdId() + "='" + temp + "'";
                    }
                }
            }

            //保存前先判断重复文件数据
            if (CollectionUtils.isNotEmpty(pzFileSjList)) {
                List<CcFileInfoVO> list = ccFileInfoMapper.findCcFileInfo(fileTypeId, "WHERE state='Y' AND M007 NOT LIKE '%" + sjLogSub1PO.getDzwjh().substring(0, 16) + "%'" + checkSql);
                if (CollectionUtils.isNotEmpty(list)) {
                    if (list.size() > 1) {
                        throw new AssertException("重复数据判断异常");
                    }
                    String arcType = list.get(0).getArcType();
                    if ("Y".equals(arcType)) {
                        //已立卷，该数据不再下载
                        SjLogErrorPO sjLogErrorPO = new SjLogErrorPO();
                        sjLogErrorPO.setSjLogSub1Id(sjLogSub1PO != null ? sjLogSub1PO.getId() : null);
                        sjLogErrorPO.setSjLogSub2Id(null);
                        sjLogErrorPO.setErrorMsg("该文件已收集且已立卷，不再重复收集,对应已立卷电子文件号" + list.get(0).getM007());
                        sjLogErrorMapper.insert(sjLogErrorPO);


                        sjLogSub1PO.setSjState(ManageConstant.CommonStateEnum.COLAIL.getCode());
                        sjLogSub1Mapper.updateById(sjLogSub1PO);

                        throw new AssertException(fileTypeId + "该批次文件已收集且已立卷，不再重复收集");
                    } else {
                        //未立卷，逻辑删除旧数据
                        handleRepeat(list, fileTypeId, ermsOrganizationPO);
                    }
                }
            }

            //补充新增的字段数据
            sqlFjOne.append(",qy_id,organization_id");
            sqlFjTwo.append(",'" + ermsQiyePO.getId() + "'");
            sqlFjTwo.append(",'" + ermsOrganizationPO.getId() + "'");

            String customFjSql = sqlFjOne.append(" )").toString() + " VALUES " + sqlFjTwo.append(" )").toString();
            //保存元数据信息
            ccFileInfoMapper.addFileInfo(fileTypeId, customFjSql);
        }

        List<SjMdXtPO> sjmd = mdXtPOList.stream().filter(item -> ManageConstant.M066.equals(item.getMdId())).collect(Collectors.toList());

        if(sjmd.size()>0){
            this.M066Operate(xtId, fileTypeId, uuid, dzwjh, map, sjLogSub1PO, sjLogSub2PO, ermsOrganizationPO);
        }
    }

    /*
     * 保存文件
     * */
    private void M066Operate(String xtId, Integer fileTypeId, String uuid, String dzwjh, Map<String,String> map, SjLogSub1PO sjLogSub1PO, SjLogSub2PO sjLogSub2PO, ErmsOrganizationPO ermsOrganizationPO){
        String updateSql = " ";

        //下载文件
        int pagenumber = 0;
        JSONObject fjObject = new JSONObject();
        fjObject.set("xtId", xtId);
        fjObject.set("fileTypeId", fileTypeId + "");
        List<SjFileSaveParamPO> sjFileSaveParamPOs = sjFileSaveParamMapper.getList(fileTypeId, xtId);
        Map fjMap = new HashMap();
        for (SjFileSaveParamPO sjFileSaveParamPO : sjFileSaveParamPOs) {
            String value = map.get(sjFileSaveParamPO.getFileKey());
            if(value == null){

            }else if(value.startsWith("{")){
                fjMap.put(sjFileSaveParamPO.getFileKey(), JSONUtil.toBean(value, Map.class));
            }else if(value.startsWith("[")){
                JSONArray objects =JSONUtil.parseArray(value);
                fjMap.put(sjFileSaveParamPO.getFileKey(), JSONUtil.toList(objects, Map.class));
            }else {
                fjMap.put(sjFileSaveParamPO.getFileKey(), value);
            }
        }
        fjObject.set("param", fjMap);
        String errMsg = null;
        String status = "";

        try {
            //调用接口，获取文件信息
            String res = HttpUtil.openHttpByPost("http://192.168.106.150:39091/" + "sjCollection/sjFile", fjObject.toString());
            JSONObject jsonRes = JSONUtil.parseObj(res);
            status = jsonRes.getStr("status");
            if (StringUtils.equals("200", status)) {
                //调用接口成功，保存文件
                Map data = jsonRes.get("data", Map.class);

                String fileData = (String) data.get("fileData");
                String format = (String) data.get("fileType");
                BigDecimal fileSize = (BigDecimal) data.get("fileSize");

                String targetPath = basePath + File.separator + fileTypeId;

                String targetName = dzwjh + "." + format;

                String fileName = targetPath + File.separator + targetName;

                InputStream stream = new ByteArrayInputStream(Base64Utils.decode(fileData.getBytes(StandardCharsets.UTF_8)));
                FilePO filePO = fileService.save(stream, targetPath, targetName);

                File file = new File(fileName);

                if(ManageConstant.CommonStateEnum.COLEND.getCode().equals(filePO.getState())) {
                    if (format.equals("pdf")) {
                        //如果是pdf文件，加签名
                        FileInputStream inputStream = new FileInputStream(file);
                        PdfReader pdfReader = new PdfReader(inputStream);
                        pagenumber = pdfReader.getNumberOfPages();
                        pdfReader.close();
                        inputStream.close();
                        //获取证书
                        QueryWrapper example = new QueryWrapper<ErmsQzCertPO>();
                        example.eq(ErmsQzCertPO.ORGANIZATION_NO, ermsOrganizationPO.getOrganizationNo());
                        example.eq(ErmsQzCertPO.XT_ID, xtId);
                        example.eq(ErmsQzCertPO.STATE, "Y");
                        ErmsQzCertPO cert = ermsQzCertMapper.selectOne(example);

                        //todo 下载文件 加密 盖章
                        if (cert != null) {
                            CommonUtil.base64ToFile(cert.getCertFile(), "cert.pfx");
                            CommonUtil.base64ToFile(cert.getImg().replaceFirst("data:image/png;base64,", ""), "image.png");

                            fileName = AposePdfUtil.insertSignature(fileName, "cert.pfx", cert.getPassword(), cert.getOrganizationNo() + "_" + cert.getXtId(), "image.png");

                            File certFile = new File(fileName);
                            long size = FileUtils.sizeOf(certFile);
                            fileSize = new BigDecimal(String.valueOf(size));
                            fileSize = fileSize.divide(new BigDecimal((String.valueOf("1024"))));
                        }
                    } else {
                        //其他类型的文件默认页数是1
                        pagenumber = 1;
                    }
                    //保存文件信息
                    CcFileSaveInfoPO ccFileSaveInfoPO = new CcFileSaveInfoPO();
                    ccFileSaveInfoPO.setFileSize(fileSize.setScale(2, BigDecimal.ROUND_HALF_UP).doubleValue());
                    ccFileSaveInfoPO.setFilePath(fileName);
                    ccFileSaveInfoPO.setFileType(format);
                    ccFileSaveInfoMapper.insert(ccFileSaveInfoPO);
                    Integer ccFileSaveInfoId = ccFileSaveInfoPO.getId();
                    updateSql += ManageConstant.M066 + " = " + ccFileSaveInfoId + ", " + ManageConstant.M043 + " = " + pagenumber;
                }
            } else {
                //获取文件不存在
                errMsg = jsonRes.getStr("msg");
                throw new Exception(errMsg);
            }
        } catch (Exception e) {
            errMsg = e.getMessage();
        } finally {
            if (errMsg != null) {
                //采集文件发生错误，保存错误信息，更新对应sub记录的状态
                SjLogErrorPO sjLogErrorPO = new SjLogErrorPO();
                sjLogErrorPO.setSjLogSub1Id(sjLogSub1PO != null ? sjLogSub1PO.getId() : null);
                sjLogErrorPO.setSjLogSub2Id(sjLogSub2PO != null ? sjLogSub2PO.getId() : null);
                sjLogErrorPO.setErrorMsg(errMsg);
                sjLogErrorMapper.insert(sjLogErrorPO);

                if (sjLogSub2PO != null) {
                    sjLogSub2PO.setSjState(ManageConstant.CommonStateEnum.COLAIL.getCode());
                    sjLogSub2Mapper.updateById(sjLogSub2PO);
                }

                sjLogSub1PO.setSjState(ManageConstant.CommonStateEnum.COLAIL.getCode());
                sjLogSub1Mapper.updateById(sjLogSub1PO);
            }else{
                //如果获取文件成功且没有错误信息，更新文件信息及对应sub记录的状态
                if (StringUtils.equals("200", status)) {
                    ccFileInfoMapper.upDateFile(fileTypeId, updateSql, uuid);
                    if (sjLogSub2PO != null) {
                        sjLogSub2PO.setSjState(ManageConstant.CommonStateEnum.COLEND.getCode());
                        sjLogSub2Mapper.updateById(sjLogSub2PO);
                        sjLogSub2InfoMapper.updateState(sjLogSub2PO.getId(),ManageConstant.CommonStateEnum.COLEND.getCode());
                    }else{
                        sjLogSub1InfoMapper.updateState(sjLogSub1PO.getId(),ManageConstant.CommonStateEnum.COLEND.getCode());
                    }
                }
            }
        }
    }

    /**
     * 已收集未立卷重复文件处理
     *
     * @param list
     * @param fileTypeId
     * @param ermsOrganizationPO
     */
    public void handleRepeat(List<CcFileInfoVO> list, Integer fileTypeId, ErmsOrganizationPO ermsOrganizationPO) {
        //如果list不为空
        if (CollectionUtils.isNotEmpty(list)) {
            //遍历
            for (CcFileInfoVO ccFileInfo : list) {
                //如果是未立卷
                if (StringUtils.equals(ccFileInfo.getArcType(), "N")) {
                    //根据cc_file_info表中的主键id查询路径
                    CcFileSaveInfoPO ccFileSaveInfo = ccFileSaveInfoMapper.selectById(ccFileInfo.getM066());
                    if (ccFileSaveInfo != null) {
                        //根据路径删除文件--》移动到删除文件夹
                        File oldFile = new File(ccFileSaveInfo.getFilePath());
                        String newPath = basePath + File.separator + "deleteFile" + File.separator + + fileTypeId + File.separator;

                        File fnewpath = new File(newPath);
                        if (!fnewpath.exists()) {
                            fnewpath.mkdirs();
                        }
                        File fnew = new File(newPath + oldFile.getName());
                        oldFile.renameTo(fnew);
                        oldFile.delete();
                    }
                    //根据cc_file_info表中的主键id逻辑删除cc_file_save_info表中的数据
                    CcFileSaveInfoPO ccFileSaveInfoPO = ccFileSaveInfoMapper.selectById(ccFileInfo.getM066());
                    ccFileSaveInfoPO.setState("N");
                    ccFileSaveInfoMapper.updateById(ccFileSaveInfoPO);

                    String zjDzwjh = ccFileInfoMapper.getDzwjh(fileTypeId, ccFileInfo.getArcType(), ermsOrganizationPO == null ? null : ermsOrganizationPO.getOrganizationName(), ccFileInfo.getM066());
                    //根据arc_type、全宗名称与M066逻辑删除cc_file_info表中的数据
                    ccFileInfoMapper.delete(fileTypeId, ccFileInfo.getArcType(), ermsOrganizationPO == null ? null : ermsOrganizationPO.getOrganizationName(), ccFileInfo.getM066());

                    // 获取附件类型列表
                    QueryWrapper example = new QueryWrapper();
                    example.eq("file_dzwjh", zjDzwjh);
                    example.eq("file_type_id", fileTypeId);
                    List<GxFileAttPO> gxFileAttPOListxFileAttPO = gxFileAttMapper.selectList(example);
                    // 附件类型列表
                    for (GxFileAttPO gxFileAttPO : gxFileAttPOListxFileAttPO) {
                        Map fjMap = ccFileInfoMapper.getUrl(gxFileAttPO.getAttTypeId(), gxFileAttPO.getAttDzwjh());
                        if (fjMap != null) {
                            String fjM066Id = (String) fjMap.get("M066");
                            CcFileSaveInfoPO fjccFileSaveInfo = ccFileSaveInfoMapper.selectById(fjM066Id);
                            if (fjccFileSaveInfo != null) {
                                //根据路径删除附件 todo 未测试
                                new File(fjccFileSaveInfo.getFilePath()).delete();
                            }
                            //根据cc_file_info表中的主键id逻辑删除cc_file_save_info表中的数据
                            CcFileSaveInfoPO fjCcFileSaveInfo = ccFileSaveInfoMapper.selectById(fjM066Id);
                            fjCcFileSaveInfo.setState("N");
                            ccFileSaveInfoMapper.updateById(fjCcFileSaveInfo);

                            //根据arc_type、全宗名称与M066逻辑删除cc_file_info表中的数据
                            ccFileInfoMapper.deleteFj(gxFileAttPO.getAttTypeId(), gxFileAttPO.getAttDzwjh());

                            gxFileAttPO.setState("N");
                            gxFileAttMapper.updateById(gxFileAttPO);
                        }
                    }
                } else {
                    //抛出自定义异常
                    throw new AssertException(fileTypeId + "文件存在已立卷数据，请勿重复收集");
                }
            }
        }
    }
}
